Solid Example: Multi Step Wizard

/* @refresh reload */
import { render } from 'solid-js/web'
import { WizardPage } from './features/wizard/page.tsx'

function App() {
  return <WizardPage />
}

const root = document.getElementById('root')

render(() => <App />, root!)
/* @refresh reload */
import { render } from 'solid-js/web'
import { WizardPage } from './features/wizard/page.tsx'

function App() {
  return <WizardPage />
}

const root = document.getElementById('root')

render(() => <App />, root!)

Angular Example: Multi Step Wizard

import { Component, signal } from '@angular/core'
import {
  TanStackWithForm,
  injectForm,
  injectStore,
  revalidateLogic,
} from '@tanstack/angular-form'
import { z } from 'zod'
import { Step1Component } from './step1.component'
import { Step2Component } from './step2.component'
import { step1Schema, step2Schema, wizardFormOpts } from './shared-form'

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [TanStackWithForm, Step1Component, Step2Component],
  template: `
    @if (step() === 0) {
      <app-step1
        tanstack-with-form
        [form]="form"
        [step]="step()"
        [isSubmitting]="isSubmitting()"
        (stepChange)="step.set($event)"
      />
    }
    @if (step() === 1) {
      <app-step2
        tanstack-with-form
        [form]="form"
        [step]="step()"
        [isSubmitting]="isSubmitting()"
        (stepChange)="step.set($event)"
      />
    }
  `,
})
export class AppComponent {
  step = signal(0)

  form = injectForm({
    ...wizardFormOpts,
    validationLogic: revalidateLogic(),
    // onDynamic is only used when `form.handleSubmit` is called itself.
    // When the FormGroup's `handleSubmit` is called, it will only validate the
    // current step's schema. This means that this schema will not be called
    // when the user submits the form group, but instead when they submit the
    // entire form.
    validators: {
      onDynamic: z.object({
        step1: step1Schema,
        step2: step2Schema,
      }),
    },
    onSubmit: ({ value }) => {
      alert(`Form submitted: ${JSON.stringify(value)}`)
    },
  })

  isSubmitting = injectStore(this.form, (state) => state.isSubmitting)
}
import { Component, signal } from '@angular/core'
import {
  TanStackWithForm,
  injectForm,
  injectStore,
  revalidateLogic,
} from '@tanstack/angular-form'
import { z } from 'zod'
import { Step1Component } from './step1.component'
import { Step2Component } from './step2.component'
import { step1Schema, step2Schema, wizardFormOpts } from './shared-form'

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [TanStackWithForm, Step1Component, Step2Component],
  template: `
    @if (step() === 0) {
      <app-step1
        tanstack-with-form
        [form]="form"
        [step]="step()"
        [isSubmitting]="isSubmitting()"
        (stepChange)="step.set($event)"
      />
    }
    @if (step() === 1) {
      <app-step2
        tanstack-with-form
        [form]="form"
        [step]="step()"
        [isSubmitting]="isSubmitting()"
        (stepChange)="step.set($event)"
      />
    }
  `,
})
export class AppComponent {
  step = signal(0)

  form = injectForm({
    ...wizardFormOpts,
    validationLogic: revalidateLogic(),
    // onDynamic is only used when `form.handleSubmit` is called itself.
    // When the FormGroup's `handleSubmit` is called, it will only validate the
    // current step's schema. This means that this schema will not be called
    // when the user submits the form group, but instead when they submit the
    // entire form.
    validators: {
      onDynamic: z.object({
        step1: step1Schema,
        step2: step2Schema,
      }),
    },
    onSubmit: ({ value }) => {
      alert(`Form submitted: ${JSON.stringify(value)}`)
    },
  })

  isSubmitting = injectStore(this.form, (state) => state.isSubmitting)
}

Vue Example: Multi Step Wizard

<script setup lang="ts">
import { revalidateLogic, useForm } from '@tanstack/vue-form'
import { ref } from 'vue'
import { z } from 'zod'
import { step1Schema, step2Schema, wizardFormOpts } from './shared-form'

const step = ref(0)

const form = useForm({
  ...wizardFormOpts,
  validationLogic: revalidateLogic(),
  validators: {
    // onDynamic is only used when `form.handleSubmit` is called itself.
    // When `form.FormGroup`'s `handleSubmit` is called, it will only validate the current step's schema.
    // This means that this schema will not be called when the user submits the form group, but instead when they submit the entire form.
    onDynamic: z.object({
      step1: step1Schema,
      step2: step2Schema,
    }),
  },
  onSubmit: ({ value }) => {
    alert(`Form submitted: ${JSON.stringify(value)}`)
  },
})

const onGroupSubmit = () => {
  step.value++
}

const onGroupSubmitInvalid = () => {
  // Just like a form, you can also handle invalid submits at the group level, which is useful for multi-step wizards to prevent going to the next step if the current step is invalid
}

const stringify = (value: unknown) => JSON.stringify(value, null, 2)
</script>

<template>
  <form.FormGroup
    v-if="step === 0"
    name="step1"
    :validators="{ onDynamic: step1Schema }"
    :onGroupSubmit="onGroupSubmit"
    :onGroupSubmitInvalid="onGroupSubmitInvalid"
    v-slot="{ group: formGroup }"
  >
    <form @submit.prevent.stop="formGroup.handleSubmit()">
      <form.Field name="step1.name" v-slot="{ field }">
        <div>
          <label>
            <div>Step 1 Name</div>
            <input
              :value="field.state.value"
              @input="
                field.handleChange(($event.target as HTMLInputElement).value)
              "
              @blur="field.handleBlur()"
            />
          </label>
          <div
            v-for="error of field.state.meta.errors"
            :key="error?.message"
            style="color: red"
          >
            {{ error?.message }}
          </div>
        </div>
      </form.Field>
      <form.Subscribe
        :selector="(state) => state.isSubmitting"
        v-slot="isSubmitting"
      >
        <button type="submit" :disabled="isSubmitting">Submit</button>
      </form.Subscribe>
      <!-- formGroup contains errorMaps and errors, just like forms and fields -->
      <pre>{{ stringify(formGroup.state.meta.errorMap) }}</pre>
    </form>
  </form.FormGroup>
  <form.FormGroup
    v-if="step === 1"
    name="step2"
    :validators="{ onDynamic: step2Schema }"
    :onGroupSubmit="() => form.handleSubmit()"
    v-slot="{ group: formGroup }"
  >
    <form @submit.prevent.stop="formGroup.handleSubmit()">
      <form.Field name="step2.name" v-slot="{ field }">
        <div>
          <label>
            <div>Step 2 Name</div>
            <input
              :value="field.state.value"
              @input="
                field.handleChange(($event.target as HTMLInputElement).value)
              "
              @blur="field.handleBlur()"
            />
          </label>
          <div
            v-for="error of field.state.meta.errors"
            :key="error?.message"
            style="color: red"
          >
            {{ error?.message }}
          </div>
        </div>
      </form.Field>
      <button @click="step--">Back</button>
      <form.Subscribe
        :selector="(state) => state.isSubmitting"
        v-slot="isSubmitting"
      >
        <button type="submit" :disabled="isSubmitting">Submit</button>
      </form.Subscribe>
    </form>
  </form.FormGroup>
</template>
<script setup lang="ts">
import { revalidateLogic, useForm } from '@tanstack/vue-form'
import { ref } from 'vue'
import { z } from 'zod'
import { step1Schema, step2Schema, wizardFormOpts } from './shared-form'

const step = ref(0)

const form = useForm({
  ...wizardFormOpts,
  validationLogic: revalidateLogic(),
  validators: {
    // onDynamic is only used when `form.handleSubmit` is called itself.
    // When `form.FormGroup`'s `handleSubmit` is called, it will only validate the current step's schema.
    // This means that this schema will not be called when the user submits the form group, but instead when they submit the entire form.
    onDynamic: z.object({
      step1: step1Schema,
      step2: step2Schema,
    }),
  },
  onSubmit: ({ value }) => {
    alert(`Form submitted: ${JSON.stringify(value)}`)
  },
})

const onGroupSubmit = () => {
  step.value++
}

const onGroupSubmitInvalid = () => {
  // Just like a form, you can also handle invalid submits at the group level, which is useful for multi-step wizards to prevent going to the next step if the current step is invalid
}

const stringify = (value: unknown) => JSON.stringify(value, null, 2)
</script>

<template>
  <form.FormGroup
    v-if="step === 0"
    name="step1"
    :validators="{ onDynamic: step1Schema }"
    :onGroupSubmit="onGroupSubmit"
    :onGroupSubmitInvalid="onGroupSubmitInvalid"
    v-slot="{ group: formGroup }"
  >
    <form @submit.prevent.stop="formGroup.handleSubmit()">
      <form.Field name="step1.name" v-slot="{ field }">
        <div>
          <label>
            <div>Step 1 Name</div>
            <input
              :value="field.state.value"
              @input="
                field.handleChange(($event.target as HTMLInputElement).value)
              "
              @blur="field.handleBlur()"
            />
          </label>
          <div
            v-for="error of field.state.meta.errors"
            :key="error?.message"
            style="color: red"
          >
            {{ error?.message }}
          </div>
        </div>
      </form.Field>
      <form.Subscribe
        :selector="(state) => state.isSubmitting"
        v-slot="isSubmitting"
      >
        <button type="submit" :disabled="isSubmitting">Submit</button>
      </form.Subscribe>
      <!-- formGroup contains errorMaps and errors, just like forms and fields -->
      <pre>{{ stringify(formGroup.state.meta.errorMap) }}</pre>
    </form>
  </form.FormGroup>
  <form.FormGroup
    v-if="step === 1"
    name="step2"
    :validators="{ onDynamic: step2Schema }"
    :onGroupSubmit="() => form.handleSubmit()"
    v-slot="{ group: formGroup }"
  >
    <form @submit.prevent.stop="formGroup.handleSubmit()">
      <form.Field name="step2.name" v-slot="{ field }">
        <div>
          <label>
            <div>Step 2 Name</div>
            <input
              :value="field.state.value"
              @input="
                field.handleChange(($event.target as HTMLInputElement).value)
              "
              @blur="field.handleBlur()"
            />
          </label>
          <div
            v-for="error of field.state.meta.errors"
            :key="error?.message"
            style="color: red"
          >
            {{ error?.message }}
          </div>
        </div>
      </form.Field>
      <button @click="step--">Back</button>
      <form.Subscribe
        :selector="(state) => state.isSubmitting"
        v-slot="isSubmitting"
      >
        <button type="submit" :disabled="isSubmitting">Submit</button>
      </form.Subscribe>
    </form>
  </form.FormGroup>
</template>

React Example: Multi Step Wizard

import * as React from 'react'
import { createRoot } from 'react-dom/client'

import { TanStackDevtools } from '@tanstack/react-devtools'
import { formDevtoolsPlugin } from '@tanstack/react-form-devtools'

import App from './App.tsx'

const rootElement = document.getElementById('root')!

createRoot(rootElement).render(
  <React.StrictMode>
    <App />

    <TanStackDevtools
      config={{ hideUntilHover: true }}
      plugins={[formDevtoolsPlugin()]}
    />
  </React.StrictMode>,
)
import * as React from 'react'
import { createRoot } from 'react-dom/client'

import { TanStackDevtools } from '@tanstack/react-devtools'
import { formDevtoolsPlugin } from '@tanstack/react-form-devtools'

import App from './App.tsx'

const rootElement = document.getElementById('root')!

createRoot(rootElement).render(
  <React.StrictMode>
    <App />

    <TanStackDevtools
      config={{ hideUntilHover: true }}
      plugins={[formDevtoolsPlugin()]}
    />
  </React.StrictMode>,
)

Svelte Example: Multi Step Wizard

<script lang="ts">
  import WizardPage from './features/wizard/page.svelte'
</script>

<WizardPage />
<script lang="ts">
  import WizardPage from './features/wizard/page.svelte'
</script>

<WizardPage />